// C Source File
// Created 6/23/2006; 8:24:09 PM
/*
Copyright (C) 2006  nebousuru

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/
//NOTE: Part of this code may not be gpl'ed, as i do not own it, and is marked such. (look at kanadata.h for details)

// Delete or comment out the items you do not need.
#define COMMENT_PROGRAM_NAME   "japime966"
#define COMMENT_VERSION_NUMBER 0,9,6,6 /* major, minor, revision, subrevision */
#define COMMENT_AUTHORS        "nebousuru"

//#define USE_TI89//only make for the ti-89



#include <tigcclib.h>

#define KANA_HEIGHT 16
#define TENTENMARU_HEIGHT 3
#include "kanadata.h"// this is sprite data and search strings, mostly from jplib by bentensai


/*to add...

	store buffer in an external file
	small characters (both tsu's, katakana a-line)
	
	*/
	
/*	parse a long string into peices that can be run through a func to display japanese
			make it so it reads first char, and if it is a vowel, it passes it onto the func
			if it is a consonant, then get a second char.  if the second is a vowel, then pass both 1 & 2 to the func
			if it is again a consonant, then get a third char.  if it is a vowel, pass all of them to the func.  if ti is a consonant, scratch previous three and get next(start over)
*/



//control strings
/*const char kanji[6] = "kanji";//unused
const char hiragana[10] = "hiragana";//unused
const char katakana[10] = "katakana";//unused*/
const char end[4] = "end";
const char off_str[4] = "off";
const char cls[4] = "cls";
const char hlp[4] = "hlp";
const char pts[4] = "pts";
const char prs[4] = "prs";
const char cst[4] = "cst";
const char prp[4] = "prp";

//control vars
  char str_buffer[4] = {0};
  const char blank[1] = "";
  char store[500] = "";
  int x = 0;
  int y = 0;
  int loop = -1;
  int pageloop = -1;
  int charcounter = 0;
  LCD_BUFFER lcdbuffer;


///varibles used here are for parse function
	const char vowel[11][2] = {"a","e","i","o","u","A","E","I","O","U"};
	const char consonant[43][2] = {"b","c","d","f","g","h","j","k","l","m","n","p","q","r","s","t","v","w","x","y","z","B","C","D","F","G","H","J","K","L","M","N","P","Q","R","S","T","V","W","X","Y","Z"};
	//const char numbersymbol[10][2] = {"0","1","2","3","4","5","6","7","8","9"};
	char parse_buffer[4] = {};
	char parsehold[4] = "";
  int offset = 0;
  int i = 0;
  
 const int vowellength = 10;//i don't know if this should be 9, 10 or 11
 const int consonantlength = 42;//i don't know if this should be 42, 43 or 44
//



#include "spritesearch.h"//function to display sprite
#include "imefunc.h"// this is the other functions, like line break and newpage  it needs to be after the global vars above

// Main Function
void _main(void)
{

int startscreentest = 0;
if(startscreentest == 0){
		clrscr();
		startscreen();
		pagebreak();
		x++;
		}
		
	INPUT:
	
	if (charcounter > 26) {
    printf("\n\nclearing\nscreen");
    ngetchx();
    charcounter = 0;
  	newpage();
  }
	
	//getinput and control line and page/////////////////////////////
	loop++;
	getsn(str_buffer,4);// GET INPUT HERE
	///////////////////////////////////////
	
	//strlen();
	*strcat(store,str_buffer);//copy input to store

	
	//control str///////////////////////
	//end test
	if (strcmp(str_buffer,end) == 0) {
  	goto END;
  }
  //test for blank
  if (strcmp(str_buffer,blank) == 0) {
  	loop--;
  	goto INPUT;
  }
  /*//test for number and symbol --- this doesn't work
  for(i=0;i==9;i++){
  if (strcmp(str_buffer,&numbersymbol[i]) == 0) {
  	loop--;
  	goto INPUT;
  }}*/
  //off test
  if (strcmp(str_buffer,off_str) == 0) {
  	off();
  	/*newline();*/
  	loop--;
  	goto INPUT;
  }
  //cls test
  if (strcmp(str_buffer,cls) == 0) {
  	newpage();
  	goto INPUT;
  }
  //help test
  if (strcmp(str_buffer,hlp) == 0) {
  	help();
  	goto INPUT;
  }
  //print buffer test
  if (strcmp(str_buffer,pts) == 0) {
  	newpage();
  	printf(store);
  	ngetchx();
  	newpage();
  	printf("length of buffer store: %lu",strlen(store)); //this displays length of string
  	ngetchx();
  	newpage();
  	goto INPUT;
  	}
  	//parse test
  	if (strcmp(str_buffer,prs) == 0) {
  	parse();
  	goto INPUT;
  }
  //parse, then print
  if (strcmp(str_buffer,prp) == 0){
  	parseprint();
  	//goto INPUT;
  }  
    //clear input buffer store
  	if (strcmp(str_buffer,cst) == 0) {
  	clearstore();
  	goto INPUT;
  }
  
  /////////////////////////////////////
  
 //char counter//
charcounter++;
// 
  
  //draw sprite

drawsprite(str_buffer);
  
//sprite mover//////////////////////////////////based on a section of code from http://www.technoplaza.net/
			x+=16; //this is normal inline offset
				
			if (x > (LCD_WIDTH - 16)) {
				x=0; //carrige return
				y+=18; //start new line
			}
///////////////////////////////////////////////end http://www.technoplaza.net/ based code






goto INPUT;


	END:  //exit
	clrscr();
	/*printf("ENDING\n");
	clrscr();*/
	printf("resetting varibles\n");
	//reset varibles to initial values so they are not overwritten if program is run unarchived
	
	
	for(i=0;i==3;i++){
	str_buffer[i] = *"\0";
  }

  *strcpy(store,"");
  
  x = 0;
  y = 0;
  loop = -1;
  pageloop = -1;
  charcounter = 0;
	offset = 0;
  i = 0;
	/////////////////////////////
	printf("done\n\npress any key to quit...");
	

	ngetchx();
}

